import { ICommonsAiModel } from '../interfaces/icommons-ai-model';
import { ICommonsAiEarlyStopping } from '../interfaces/icommons-ai-early-stopping';
import { TCommonsAiCrossValidationK } from '../types/tcommons-ai-cross-validation-k';
import { TCommonsAiGenericTrainingData } from '../types/tcommons-ai-generic-training-data';
import { TCommonsAiModelWithQuality } from '../types/tcommons-ai-model-with-quality';
export declare function commonsAiCrossValidationBuildKs<I, O>(trainingData: TCommonsAiGenericTrainingData<I, O>[], iterations: number): TCommonsAiCrossValidationK<TCommonsAiGenericTrainingData<I, O>>[];
export declare function commonsAiCrossValidationBuildEnumKs<I, E extends string>(keys: E[], trainingData: Map<E, I[]>, iterations: number): TCommonsAiCrossValidationK<TCommonsAiGenericTrainingData<I, E>>[];
export declare function commonsAiCrossValidationTrain<I, O, M extends ICommonsAiModel<I, O>>(crossValidationKs: TCommonsAiCrossValidationK<TCommonsAiGenericTrainingData<I, O>>[], modelConstructorCallback: (training: TCommonsAiGenericTrainingData<I, O>[], epochs: number, testing: TCommonsAiGenericTrainingData<I, O>[] | undefined, earlyStopping: ICommonsAiEarlyStopping | undefined) => M, epochs: number, earlyStopping?: ICommonsAiEarlyStopping): Promise<TCommonsAiModelWithQuality<I, O, M>>;
